Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/SelfTest/src/main.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/SelfTest/src/main.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/SelfTest/src/main.cpp	(revision 88)
@@ -0,0 +1,59 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Configuration/SelfTest/include/test.h"
+
+#define NB_PARAMS 0
+
+void usage (int argc, char * argv[])
+{
+  err (_("<Usage> %s name_instance.\n"),argv[0]);
+  err ("argc : %d\n",argc);
+
+  exit (1);
+}
+
+#ifndef SYSTEMC
+int main    (int argc, char * argv[])
+#else
+int sc_main (int argc, char * argv[])
+#endif
+{
+  if (argc != static_cast<int>(2+NB_PARAMS))
+    usage (argc, argv);
+
+  uint32_t x = 1;
+
+  string name     = argv[x++];
+
+  int _return = EXIT_SUCCESS;
+
+  try 
+    {
+      test (name);
+    }
+  catch (morpheo::ErrorMorpheo & error)
+    {
+      msg (_("<%s> :\n%s"),name.c_str(), error.what ());
+      _return = EXIT_FAILURE;
+    }
+
+  try 
+    {
+      if (_return == EXIT_SUCCESS)
+	TEST_OK("Configuration : no error");
+      else
+	TEST_KO("Configuration : a lot of error");
+    }
+  catch (morpheo::ErrorMorpheo & error)
+    {
+//       msg (_("<%s> :\n%s"),name.c_str(), error.what ());
+      _return = EXIT_FAILURE;
+    }
+
+  return (_return);
+}
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/SelfTest/src/test.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/SelfTest/src/test.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/SelfTest/src/test.cpp	(revision 88)
@@ -0,0 +1,85 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ * Test
+ */
+
+#include "Behavioural/Configuration/SelfTest/include/test.h"
+#include "Behavioural/Custom/include/Custom_default.h"
+#include "Behavioural/Custom/include/Custom_example.h"
+
+void test (string name)
+{
+  morpheo::behavioural::custom::custom_information_t (*_get_custom_information) (void) = &(morpheo::behavioural::custom::default_get_custom_information);
+
+  cout << "------------------------------------------------------" << endl;
+
+  Simulator * simulator1 = new Simulator ("../../../Files/Morpheo.sim");
+  
+//cout << *simulator1 << endl;
+  
+  simulator1->toFile("data_out");
+
+  cout << "------------------------------------------------------" << endl;
+
+  Generator * generator1 = new Generator ("../../../Files/Morpheo.gen");
+
+//cout << *generator1 << endl;
+
+  generator1->toFile("data_out");
+
+  cout << "------------------------------------------------------" << endl;
+
+  Instance * instance1 = new Instance ("../../../Files/Instance_min.cfg",
+                                   generator1,
+                                   _get_custom_information
+                                   );
+  
+//   cout << *instance1 << endl;
+
+  instance1->toFile("data_out");
+
+  cout << "------------------------------------------------------" << endl;
+  
+  Configuration * configuration1 = new Configuration("../../../Files/Morpheo.sim",
+                                           "../../../Files/Morpheo.gen",
+                                           "../../../Files/Instance_min.cfg",
+                                           _get_custom_information);
+
+//cout << *configuration1 << endl;
+
+  configuration1->toFile("data_out");
+
+  {
+    cout << "------------------------------------------------------" << endl;
+
+    Instance * instance = new Instance ("../../../Files/Instance_scalar_1.cfg",
+                                        generator1,
+                                        _get_custom_information
+                                        );
+    instance->toFile("data_out");
+    
+    delete instance;
+  }
+
+  {
+    cout << "------------------------------------------------------" << endl;
+
+    Instance * instance = new Instance ("../../../Files/Instance_scalar_2.cfg",
+                                        generator1,
+                                        _get_custom_information
+                                        );
+    instance->toFile("data_out");
+    
+    delete instance;
+  }
+
+  delete configuration1;
+  delete instance1;
+  delete generator1;
+  delete simulator1;
+
+
+}
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/include/Configuration.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/include/Configuration.h	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/include/Configuration.h	(revision 88)
@@ -0,0 +1,62 @@
+#ifndef morpheo_behavioural_configuration_Configuration_h
+#define morpheo_behavioural_configuration_Configuration_h
+
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Configuration/include/Simulator.h"
+#include "Behavioural/Configuration/include/Generator.h"
+#include "Behavioural/Configuration/include/Instance.h"
+#include "Behavioural/Custom/include/Custom.h"
+
+#include "Behavioural/include/Usage.h"
+#include "Behavioural/include/Parameters_Statistics.h"
+
+#include "Common/include/ToString.h"
+#include "Common/include/Debug.h"
+
+#include <iostream>
+
+namespace morpheo {
+namespace behavioural {
+namespace configuration {
+
+  class Configuration 
+  {
+    // -----[ fields ]----------------------------------------------------
+  private : std::string _name;
+  private : Simulator * _simulator;
+  private : Generator * _generator;
+  private : Instance  * _instance ;
+
+  private : Parameters * _param;
+  private : morpheo::behavioural::Parameters_Statistics * _param_statistics;
+
+  private : Tusage_t                                      _usage;
+    
+    // -----[ methods ]---------------------------------------------------
+  public   :                      Configuration  (std::string filename_simulator, 
+                                                  std::string filename_generator, 
+                                                  std::string filename_instance ,
+                                                  behavioural::custom::custom_information_t (*get_custom_information) (void));
+  public   :                     ~Configuration  ();
+
+  public   : std::string                                   getName            (void);
+  public   : Tusage_t                                      getUsage           (void);
+  public   : Parameters                                  * getParam           (void);
+  public   : morpheo::behavioural::Parameters_Statistics * getParamStatistics (void);
+
+  public   : void                 toFile         (std::string dirname=".");
+  public   : friend std::ostream& operator<<     (std::ostream& output,
+                                                  morpheo::behavioural::configuration::Configuration & x);
+  };
+
+}; // end namespace configuration
+}; // end namespace behavioural
+}; // end namespace morpheo              
+
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/include/Generator.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/include/Generator.h	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/include/Generator.h	(revision 88)
@@ -0,0 +1,57 @@
+#ifndef morpheo_behavioural_configuration_Generator_h
+#define morpheo_behavioural_configuration_Generator_h
+
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Configuration/include/Parameter_definition.h"
+#include "Behavioural/Configuration/include/Link_definition.h"
+#include "Behavioural/Configuration/include/XMLUtils.h"
+#include <map>
+
+namespace morpheo {
+namespace behavioural {
+namespace configuration {
+
+  class Generator 
+  {
+    // -----[ fields ]----------------------------------------------------
+  private  : std::string _filename;
+  private  : std::map<std::string, Parameter_definition *> * _array_param;
+  private  : std::map<std::string, Link_definition *>      * _array_link;
+
+    // -----[ methods ]---------------------------------------------------
+  public   :                        Generator  (std::string filename);
+  public   :                       ~Generator  ();
+
+  public   : Parameter_definition * getParam   (std::string name);
+  public   : Link_definition *      getLink    (std::string name);
+    
+
+  public   : void                   test       (std::string param,
+                                                std::string x);
+  public   : void                   test       (std::string link,
+                                                std::string father_name,
+                                                bool        father_is_src,
+                                                bool        father_is_dest);
+                                   
+  private  : void                   insert     (Parameter_definition * param);
+  private  : void                   insert     (Link_definition      * param);
+  private  : void                   fromFile   (std::string filename);
+                                   
+  public   : void                   toFile     (std::string dirname=".");
+  private  : XML                    toXML      (void);
+  private  : std::string            print      (uint32_t depth);
+  public   : friend std::ostream&   operator<< (std::ostream& output,
+                                              morpheo::behavioural::configuration::Generator & x);
+  };
+
+}; // end namespace configuration
+}; // end namespace behavioural
+}; // end namespace morpheo              
+
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/include/Instance.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/include/Instance.h	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/include/Instance.h	(revision 88)
@@ -0,0 +1,205 @@
+#ifndef morpheo_behavioural_configuration_Instance_h
+#define morpheo_behavioural_configuration_Instance_h
+
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Configuration/include/Parameter_affectation.h"
+#include "Behavioural/Configuration/include/Link_affectation.h"
+#include "Behavioural/Configuration/include/Generator.h"
+#include "Behavioural/Configuration/include/Parameters.h"
+#include "Behavioural/Custom/include/Custom.h"
+
+#include <map>
+#include <vector>
+#include <cstdarg>
+
+namespace morpheo {
+namespace behavioural {
+namespace configuration {
+
+  class Instance_component;
+
+  typedef std::map<std::string, Parameter_affectation *> list_parameters_t;
+  typedef std::map<std::string, Link_affectation *>      list_link_t;
+  typedef std::map<std::string, list_link_t>             list_links_t;
+  typedef std::map<std::string, Instance_component *>    list_instances_t;
+  typedef std::map<std::string, list_instances_t>        list_components_t;
+
+  class Instance_component
+  {
+  public   : const std::string _name;
+  public   : const std::string _id;
+  public   : list_parameters_t * _list_parameters;
+//public   : list_links_t      * _list_links;
+  public   : list_components_t * _list_components;
+   
+  public   :  Instance_component (std::string name,
+                                  std::string id):
+    _name (name),
+    _id   (id)
+    {
+      _list_parameters = new list_parameters_t;
+//    _list_links      = new list_links_t     ;
+      _list_components = new list_components_t;
+    }
+    
+  public   : ~Instance_component (void)
+    {
+      for (list_parameters_t::iterator it = _list_parameters->begin();
+           it != _list_parameters->end();
+           ++it)
+        delete it->second;
+      delete _list_parameters;
+      
+//       for (list_links_t::iterator it1 = _list_links->begin();
+//            it1 != _list_links->end();
+//            ++it1)
+//         for (list_link_t::iterator it2 = it1->second.begin();
+//              it2 != it1->second.end();
+//              ++it2)
+//           delete it2->second;
+//       delete _list_links;
+
+      for (list_components_t::iterator it1 = _list_components->begin();
+           it1 != _list_components->end();
+           ++it1)
+        for (list_instances_t::iterator it2 = it1->second.begin();
+             it2 != it1->second.end();
+             ++it2)
+          delete it2->second;
+      delete _list_components;
+    }
+
+#undef  FUNCTION
+#define FUNCTION "Instance_component::toXML"
+  public   : XML                  toXML                (void)
+    {
+      log_begin(Configuration,FUNCTION);
+
+      XML xml (_name);
+      
+      xml.balise_open_begin(_name);
+      xml.  attribut("id" ,_id);
+      xml.balise_open_end();
+      
+      for (list_parameters_t::iterator it = _list_parameters->begin();
+           it != _list_parameters->end();
+           ++it)
+        xml.insert_XML(it->second->toXML(),1);
+
+//       for (list_links_t::iterator it1 = _list_links->begin();
+//            it1 != _list_links->end();
+//            ++it1)
+//         for (list_link_t::iterator it2 = it1->second.begin();
+//              it2 != it1->second.end();
+//              ++it2)
+//           xml.insert_XML(it2->second->toXML(),1);
+
+      for (list_components_t::iterator it1 = _list_components->begin();
+           it1 != _list_components->end();
+           ++it1)
+        for (list_instances_t::iterator it2 = it1->second.begin();
+             it2 != it1->second.end();
+             ++it2)
+          xml.insert_XML(it2->second->toXML(),1);
+
+      xml.balise_close();
+
+      log_end(Configuration,FUNCTION);
+      return xml;
+    }
+
+#undef  FUNCTION
+#define FUNCTION "Instance_component::print"
+  private  : std::string          print                (uint32_t depth)
+    {
+      log_begin(Configuration,FUNCTION);
+      
+      std::string _return = (toXML()).get_body(depth);
+      
+      log_end(Configuration,FUNCTION);
+      return _return;
+    };
+    
+#undef  FUNCTION
+#define FUNCTION "Instance_component::operator<<"
+  public   : friend std::ostream& operator<<           (std::ostream& output,
+                                                        morpheo::behavioural::configuration::Instance_component & x)
+    {
+      log_begin(Configuration,FUNCTION);
+      output << x.print(0);
+      log_end(Configuration,FUNCTION);
+      return output;
+    };
+  };
+
+
+  class Instance
+  {
+    // -----[ fields ]----------------------------------------------------
+  private  : std::string _name;
+  private  : std::string _filename;
+//private  : list_parameters_t * _array;
+
+  public   : list_parameters_t * _list_parameters;
+  public   : list_links_t      * _list_links;
+  public   : list_components_t * _list_components;
+
+  private  : Generator  * _generator;
+  public   : Parameters * _param;
+
+    // -----[ methods ]---------------------------------------------------
+  public   :                          Instance    (std::string filename,
+                                                   Generator * generator,
+                                                   behavioural::custom::custom_information_t (*get_custom_information) (void));
+  public   :                         ~Instance    ();
+                                    
+  public   : std::string              getName     (void);
+  private  : std::string              getParam    (const char * name, ...);
+  private  : std::vector<std::string> getLink     (const char * name, ...);
+  private  : std::vector<std::string> link2array  (std::string  str);
+
+    // Test : parameter, link, component
+  public   : void                     test        (std::string type,
+                                                   std::string value);
+  public   : void                     test        (std::string type,
+                                                   std::string father_name,
+                                                   bool        father_is_src,
+                                                   bool        father_is_dest);
+  private  : void                     test        (std::string link,
+                                                   std::vector<std::string> & vect,
+                                                   uint32_t nb_elt);
+  private  : void                     test_use    (void);
+  private  : void                     test_use    (std::string name,
+                                                   list_parameters_t * list_parameters,
+                                                   list_components_t * list_components,
+                                                   std::vector<std::string> & list_not_use);
+
+  private  : void                     fromInternalStructure(void);
+                                    
+  private  : void                     fromXMLLight(XML_t * xml,
+                                                   attribute_t         id,
+                                                   list_parameters_t * list_parameters,
+                                                   list_links_t      * list_links,
+                                                   list_components_t * list_component);
+                                    
+  private  : void                     fromFile    (std::string filename);
+                                    
+  public   : void                     toFile      (std::string dirname=".");
+  private  : XML                      toXML       (void);
+  private  : std::string              print       (uint32_t depth);
+  public   : friend std::ostream&     operator<<  (std::ostream& output,
+                                                   morpheo::behavioural::configuration::Instance & x);
+
+  };
+
+}; // end namespace configuration
+}; // end namespace behavioural
+}; // end namespace morpheo              
+
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/include/Link_affectation.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/include/Link_affectation.h	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/include/Link_affectation.h	(revision 88)
@@ -0,0 +1,48 @@
+#ifndef morpheo_behavioural_configuration_Link_affectation_h
+#define morpheo_behavioural_configuration_Link_affectation_h
+
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/XML.h"
+#include "Common/include/ErrorMorpheo.h"
+#include "Common/include/ToString.h"
+#include "Common/include/Debug.h"
+
+#include <iostream>
+
+namespace morpheo {
+namespace behavioural {
+namespace configuration {
+
+  class Link_affectation 
+  {
+    // -----[ fields ]----------------------------------------------------
+    // Constant
+  public   : const std::string _name;
+  public   : const std::string _src ;
+  public   : const std::string _dest;
+  public   :       bool        _use ;
+
+    // -----[ methods ]---------------------------------------------------
+  public   :                      Link_affectation (std::string name,
+                                                    std::string src ,
+                                                    std::string dest
+                                                    );
+  public   :                     ~Link_affectation ();
+    
+  public   : XML                  toXML            (void);
+  private  : std::string          print            (uint32_t depth);
+  public   : friend std::ostream& operator<<       (std::ostream& output,
+                                                    morpheo::behavioural::configuration::Link_affectation & x);
+  };
+
+}; // end namespace configuration
+}; // end namespace behavioural
+}; // end namespace morpheo              
+
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/include/Link_definition.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/include/Link_definition.h	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/include/Link_definition.h	(revision 88)
@@ -0,0 +1,52 @@
+#ifndef morpheo_behavioural_configuration_Link_definition_h
+#define morpheo_behavioural_configuration_Link_definition_h
+
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/XML.h"
+#include "Common/include/ErrorMorpheo.h"
+#include "Common/include/ToString.h"
+#include "Common/include/Debug.h"
+
+#include <iostream>
+
+namespace morpheo {
+namespace behavioural {
+namespace configuration {
+
+
+  class Link_definition 
+  {
+    // -----[ fields ]----------------------------------------------------
+    // Constant
+  public   : const std::string _name       ;
+  public   : const std::string _src        ;
+  public   : const std::string _dest       ;
+  public   : const std::string _description;
+
+    // -----[ methods ]---------------------------------------------------
+  public   :                      Link_definition  (std::string name         ,
+                                                    std::string src          ,
+                                                    std::string dest         ,
+                                                    std::string description  );
+  public   :                     ~Link_definition ();
+
+//public   : bool                 test            (uint32_t x);
+
+  public   : XML                  toXML           (void);
+  private  : std::string          print           (uint32_t depth);
+  public   : friend std::ostream& operator<<      (std::ostream& output,
+                                                   morpheo::behavioural::configuration::Link_definition & x);
+
+  };
+
+}; // end namespace configuration
+}; // end namespace behavioural
+}; // end namespace morpheo              
+
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/include/Parameter_affectation.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/include/Parameter_affectation.h	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/include/Parameter_affectation.h	(revision 88)
@@ -0,0 +1,46 @@
+#ifndef morpheo_behavioural_configuration_Parameter_affectation_h
+#define morpheo_behavioural_configuration_Parameter_affectation_h
+
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/XML.h"
+#include "Common/include/ErrorMorpheo.h"
+#include "Common/include/ToString.h"
+#include "Common/include/Debug.h"
+
+#include <iostream>
+
+namespace morpheo {
+namespace behavioural {
+namespace configuration {
+
+  class Parameter_affectation 
+  {
+    // -----[ fields ]----------------------------------------------------
+    // Constant
+  public   : const std::string _name ;
+  public   : const std::string _value;
+  public   :       bool        _use  ;
+
+    // -----[ methods ]---------------------------------------------------
+  public   :                      Parameter_affectation (std::string name,
+                                                         std::string value
+                                                         );
+  public   :                     ~Parameter_affectation ();
+    
+  public   : XML                  toXML                (void);
+  private  : std::string          print                (uint32_t depth);
+  public   : friend std::ostream& operator<<           (std::ostream& output,
+                                                        morpheo::behavioural::configuration::Parameter_affectation & x);
+  };
+
+}; // end namespace configuration
+}; // end namespace behavioural
+}; // end namespace morpheo              
+
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/include/Parameter_definition.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/include/Parameter_definition.h	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/include/Parameter_definition.h	(revision 88)
@@ -0,0 +1,58 @@
+#ifndef morpheo_behavioural_configuration_Parameter_definition_h
+#define morpheo_behavioural_configuration_Parameter_definition_h
+
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/XML.h"
+#include "Common/include/ErrorMorpheo.h"
+#include "Common/include/ToString.h"
+#include "Common/include/Debug.h"
+
+#include <iostream>
+
+namespace morpheo {
+namespace behavioural {
+namespace configuration {
+
+
+  class Parameter_definition 
+  {
+    // -----[ fields ]----------------------------------------------------
+    // Constant
+  public   : const std::string _name       ;
+  public   : const std::string _min        ;
+  public   : const std::string _max        ;
+  public   : const std::string _step       ;
+  public   : const std::string _default    ;
+  public   : const std::string _level      ;
+  public   : const std::string _description;
+
+    // -----[ methods ]---------------------------------------------------
+  public   :                      Parameter_definition  (std::string name         ,
+                                                         std::string min          ,
+                                                         std::string max          ,
+                                                         std::string step         ,
+                                                         std::string value_default,
+                                                         std::string level        ,
+                                                         std::string description  );
+  public   :                     ~Parameter_definition ();
+
+  public   : void                 test                 (std::string x);
+
+  public   : XML                  toXML                (void);
+  private  : std::string          print                (uint32_t depth);
+  public   : friend std::ostream& operator<<           (std::ostream& output,
+                                                        morpheo::behavioural::configuration::Parameter_definition & x);
+
+  };
+
+}; // end namespace configuration
+}; // end namespace behavioural
+}; // end namespace morpheo              
+
+#endif
